//MASTER ARDUINO 

//include required wire library for I2C bus
#include <Wire.h>

//Send to slave instructions
int x = 0;

//DECLARE SLAVE ADDRESSES
const int slave1 = 9;
const int slave2 = 11;
const int slave3 = 15;
//declaring variables


//DECLARE PINS
//Ultrasonic
const int pingPin = 4;
const int echoPin = 3;

//Button Inputs
const int buttonY = 7;
const int buttonN = 8;

//LED
const int ledPin1 = 13;
const int ledPin2 = 12;

//Other Variables
int buttonStateY;
int buttonStateN;

//Ultrasonic distance
long duration, distance;
int distanceLimit = 45; //how far the person can be before the distance is too far and detects the person has left

//Timer
unsigned long originMillis;  //time since program started
unsigned long currentMillis; //current time tracker
unsigned long startMillis;   //time it entered loop
const unsigned long period = 7000; //5 seconds, the amount of time you have to answer the questions

//Random number
long randomLong = 1;//random(9);  //Random number maximum at 9
byte ran = '3';


//Delay timing
int timing = 3000; //this timing needs to be 1000 longer than the delay in the other arduino's because there is a .5 to 1 sec delay

void setup() {
  //DECLARE THIS ARDUINO AS MASTER ARDUINO
  //real 50 shades of grey vibes
  Wire.begin(); //Master arduino has no wire address

  Serial.begin(9600); 

  //Start timer
  originMillis = millis();
    
  //set pinMode's
  pinMode(LED_BUILTIN, OUTPUT);
  //Ultrasonic pins
  pinMode(pingPin, OUTPUT);
  pinMode(echoPin, INPUT);
  //Button pins
  pinMode(buttonY, INPUT);
  pinMode(buttonN, INPUT);
  //LED pins
  pinMode(ledPin1, OUTPUT);
  pinMode(ledPin2, OUTPUT);
}

//Function that turns microseconds to cm for the ultrasonic sensor
long microsecondsToCentimeters(long microseconds) {
   return microseconds / 29 / 2;
}

void loop() {
  //x = 0;
  //randomLong = random(9);
  //randomLong = 1;   //initiate random number
  //ran = (char)randomLong;   //change from type LONG to CHAR
  //Read button states
  buttonStateY = digitalRead(buttonY);
  buttonStateN = digitalRead(buttonN);
  Serial.print("Y ");
  Serial.println(buttonStateY);
  Serial.print("N ");
  Serial.println(buttonStateN);
  
  if(buttonStateY==HIGH){         //Shows when the button is being pressed YES
    digitalWrite(ledPin1, HIGH);
    //x = 1;
    Wire.beginTransmission(slave1);
    Wire.write(x);
    Wire.endTransmission();
  }else{
    digitalWrite(ledPin1, LOW);
  }
  
  if(buttonStateN==HIGH){         //Shows when the button is being pressed  NO
    digitalWrite(ledPin2, HIGH);
    //x = 2;
    Wire.beginTransmission(slave1);
    Wire.write(x);
    Wire.endTransmission();
  }else{
    digitalWrite(ledPin2, LOW);
  }
  
  
  
  
  startMillis = millis(); //Time if statements were entered
  
  if((char)ran == '1'){
    Serial.println("ARE YOU BEING PRODUCTIVE NOW?");
    //TRANSMIT TO SLAVE 1
    Wire.beginTransmission(slave1);
    Wire.write('1');                //Plays wav file
    Wire.endTransmission();
    //TRANSMIT TO SLAVE 2
    Wire.beginTransmission(slave2);
    Wire.write('1');                //smiles
    Wire.endTransmission();
    //TRANSMIT TO SLAVE 3
    Wire.beginTransmission(slave3);
    Wire.write('1');                //smacks
    Wire.endTransmission();
    //delay(timing)   
    
    currentMillis = millis();
    while(currentMillis-startMillis<=period){   //loops for 7 seconds
      Serial.print("Countdown: ");
      Serial.println(currentMillis-startMillis);
      //Serial.print("Button state: ");
     // Serial.println(buttonStateY);
      buttonStateY = digitalRead(buttonY);  //listening for button pressing during the while loop
      buttonStateN = digitalRead(buttonN);
      if (buttonStateY == HIGH){    //IF 'YES' BUTTON PRESSED
        
        Serial.print("Order sent: ");
        Serial.println('a');
        Wire.beginTransmission(slave1); //Addresses slave 1
        Wire.write('a');                //Plays wav file
        Wire.endTransmission();
        //TRANSMIT TO SLAVE 2
        Wire.beginTransmission(slave2);
        Wire.write('a');                //frowns
        Wire.endTransmission();
        //TRANSMIT TO SLAVE 3
        Wire.beginTransmission(slave3);
        Wire.write('a');                //smacks
        Wire.endTransmission();
        delay(timing);
              
        ran = '0';  //change the state of the director to neutral 0
        break;      //break out of the while loop
      }else if(buttonStateN==HIGH){   //IF 'NO' BUTTON IS PRESSED
        
        //Addresses slave 1
        Serial.print("Order sent: ");
        Serial.println('b');
        Wire.beginTransmission(slave1); 
        Wire.write('b');                //Plays wav file 
        Wire.endTransmission();
        //TRANSMIT TO SLAVE 2
        Wire.beginTransmission(slave2);
        Wire.write('b');                //frowns
        Wire.endTransmission();
        Wire.beginTransmission(slave3);
        Wire.write('b');                //frowns
        Wire.endTransmission();
        delay(timing);   
                    
        ran = '0';
        break;
      }
      currentMillis = millis();     //keeping time
    }
    //IF TIMEOUT
    if(ran != '0'){
      
    //Addresses slave 1
    Serial.println("Too slow");  
    Serial.print("Order sent: ");
    Serial.println('c');  
    Wire.beginTransmission(slave1); 
    Wire.write('c');                //Plays wav file
    Wire.endTransmission();
    //TRANSMIT TO SLAVE 2
    Wire.beginTransmission(slave2);
    Wire.write('c');                //frowns
    Wire.endTransmission();
    //TRANSMIT TO SLAVE 2
    Wire.beginTransmission(slave3);
    Wire.write('c');                //frowns
    Wire.endTransmission();
    delay(timing);
          
    ran = '0';
    }
  delay(7000);
  }else if((char)ran == '2'){         //HAPPY_2
    Serial.println("HAPPY_2");
    //TRANSMIT TO SLAVE 1
    Wire.beginTransmission(slave1);
    Wire.write('2');                //Plays wav file
    Wire.endTransmission();
    //TRANSMIT TO SLAVE 2
    Wire.beginTransmission(slave2);
    Wire.write('2');                //frowns
    Wire.endTransmission();
    //TRANSMIT TO SLAVE 3
    Wire.beginTransmission(slave3);
    Wire.write('2');                //smacks
    Wire.endTransmission();
    //delay(timing)   
    
    currentMillis = millis();
    while(currentMillis-startMillis<=period){   //loops for 7 seconds
      Serial.print("Countdown: ");
      Serial.println(currentMillis-startMillis);
      //Serial.print("Button state: ");
     // Serial.println(buttonStateY);
      buttonStateY = digitalRead(buttonY);  //listening for button pressing during the while loop
      buttonStateN = digitalRead(buttonN);
      if (buttonStateY == HIGH){    //IF 'YES' BUTTON PRESSED
        
        Serial.print("Order sent: ");
        Serial.println('d');
        Wire.beginTransmission(slave1); //Addresses slave 1
        Wire.write('d');                //Plays wav file
        Wire.endTransmission();
        //TRANSMIT TO SLAVE 2
        Wire.beginTransmission(slave2);
        Wire.write('d');                //frowns
        Wire.endTransmission();
        //TRANSMIT TO SLAVE 3
        Wire.beginTransmission(slave3);
        Wire.write('d');                //smacks
        Wire.endTransmission();
        
        delay(timing);
       
        ran = '0';  //change the state of the director to neutral 0
        break;      //break out of the while loop
      }else if(buttonStateN==HIGH){   //IF 'NO' BUTTON IS PRESSED
        
        //Addresses slave 1
        Serial.print("Order sent: ");
        Serial.println('e');
        
        Wire.beginTransmission(slave1); 
        Wire.write('e');                //Plays wav file
        Wire.endTransmission();
        //TRANSMIT TO SLAVE 2
        Wire.beginTransmission(slave2);
        Wire.write('e');                //frowns
        Wire.endTransmission();
        //TRANSMIT TO SLAVE 3
        Wire.beginTransmission(slave3);
        Wire.write('e');                //smacks
        Wire.endTransmission();
        
        delay(timing);   
           
        ran = '0';
        break;
      }
      currentMillis = millis();     //keeping time
    }
    //IF TIMEOUT
    if(ran != '0'){
      
    //Addresses slave 1
    Serial.println("Too slow");  
    Serial.print("Order sent: ");
    Serial.println('f');  
    Wire.beginTransmission(slave1); 
    Wire.write('f');                //Plays wav file 
    Wire.endTransmission();
    //TRANSMIT TO SLAVE 2
    Wire.beginTransmission(slave2);
    Wire.write('f');                //frowns
    Wire.endTransmission();
    //TRANSMIT TO SLAVE 3
    Wire.beginTransmission(slave3);
    Wire.write('f');                //smacks
    Wire.endTransmission();
    delay(timing);
      
    ran = '0';
    }
  delay(7000);
  }else if((char)ran == '3'){         //GREENBTTN_3
    Serial.println("GREENBTTN_3");
    //TRANSMIT TO SLAVE 1
    Wire.beginTransmission(slave1);
    Wire.write('3');                //Plays wav file
    Wire.endTransmission();
    //TRANSMIT TO SLAVE 2
    Wire.beginTransmission(slave2);
    Wire.write('3');                //frowns
    Wire.endTransmission();
    //TRANSMIT TO SLAVE 3
    Wire.beginTransmission(slave3);
    Wire.write('3');                //smacks
    Wire.endTransmission();
    //delay(timing)   
    
    currentMillis = millis();
    while(currentMillis-startMillis<=period){   //loops for 7 seconds
      Serial.print("Countdown: ");
      Serial.println(currentMillis-startMillis);
      //Serial.print("Button state: ");
     // Serial.println(buttonStateY);
      buttonStateY = digitalRead(buttonY);  //listening for button pressing during the while loop
      buttonStateN = digitalRead(buttonN);
      if (buttonStateY == HIGH){    //IF 'YES' BUTTON PRESSED
        
        Serial.print("Order sent: ");
        Serial.println('g');
        Wire.beginTransmission(slave1); //Addresses slave 1
        Wire.write('g');                //Plays wav file
        Wire.endTransmission();
        //TRANSMIT TO SLAVE 2
        Wire.beginTransmission(slave2);
        Wire.write('g');                //frowns
        Wire.endTransmission();
        //TRANSMIT TO SLAVE 3
        Wire.beginTransmission(slave3);
        Wire.write('g');                //smacks
        Wire.endTransmission();
        delay(timing);
                
        ran = '0';  //change the state of the director to neutral 0
        break;      //break out of the while loop
      }else if(buttonStateN==HIGH){   //IF 'NO' BUTTON IS PRESSED
        
        //Addresses slave 1
        Serial.print("Order sent: ");
        Serial.println('h');
        Wire.beginTransmission(slave1); 
        Wire.write('h');                //Plays wav file
        Wire.endTransmission();
        //TRANSMIT TO SLAVE 2
        Wire.beginTransmission(slave2);
        Wire.write('h');                //frowns
        Wire.endTransmission();
        //TRANSMIT TO SLAVE 3
        Wire.beginTransmission(slave3);
        Wire.write('h');                //smacks
        Wire.endTransmission();
        delay(timing);   
        //Serial.println("Why don't you get to it then?");
           

        
        ran = '0';
        break;
      }
      currentMillis = millis();     //keeping time
    }
    //IF TIMEOUT
    if(ran != '0'){
      
    //Addresses slave 1
    Serial.println("Too slow");  
    Serial.print("Order sent: ");
    Serial.println('i');  
    Wire.beginTransmission(slave1); 
    Wire.write('i');                //Plays wav file
    Wire.endTransmission();
    //TRANSMIT TO SLAVE 2
    Wire.beginTransmission(slave2);
    Wire.write('i');                //frowns
    Wire.endTransmission();
    //TRANSMIT TO SLAVE 3
    Wire.beginTransmission(slave3);
    Wire.write('i');                //smacks
    Wire.endTransmission();
    delay(timing);
      
    
    ran = '0';
    }
    delay(7000);
  }else if((char)ran == '9'){         //If user gets away from the ultrasonic
    Serial.println("GREENBTTN_3");
    //TRANSMIT TO SLAVE 1
    Wire.beginTransmission(slave1);
    Wire.write('9');                //Plays wav file
    Wire.endTransmission();
    //TRANSMIT TO SLAVE 2
    Wire.beginTransmission(slave2);
    Wire.write('9');                //teeth
    Wire.endTransmission();
    //TRANSMIT TO SLAVE 3
    Wire.beginTransmission(slave3);
    Wire.write('9');                //freaks out (smacks bunch of times
    Wire.endTransmission();
    //delay(timing)   

    ran = '0';
    
    
  }
  
  randomLong = random(1, 3);  //random number generator
  
   if((int)randomLong==1){    //converts random number to char, this is a really weird/inefficient conversion I know but I ran into lots of problems with (char) to (byte) conversion
     ran = '1';
   }else if((int)randomLong==2){
      ran = '2';
   }else if((int)randomLong==3){
      ran = '3';
   }else if((int)randomLong==4){
      ran = '4';
   }else if((int)randomLong==5){
      ran = '5';
   }

   
   //Ultrasonic sensor pings constantly
  digitalWrite(pingPin, LOW);
  delayMicroseconds(2);
  digitalWrite(pingPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(pingPin, LOW);

  duration = pulseIn(echoPin, HIGH);
  distance = microsecondsToCentimeters(duration);
 
  if(distance >= distanceLimit){     //if the person is further than x cm from the robot ultrasonics or leaves
    Serial.println("Person missing");
    ran = '9';
  }
  
  Serial.print("Random number: ");
  Serial.println(ran);
  delay(1000);
  
}
